typedef struct {
  volatile uint32_t MODER;   // mode register,              0x00
  volatile uint32_t OTYPER;  // output type register,       0x04
  volatile uint32_t OSPEEDR; // output speed register,      0x08
  volatile uint32_t PUPDR;   // pull-up/-down register,     0x0C
  volatile uint32_t IDR;     // input data register,        0x10
  volatile uint32_t ODR;     // output data register,       0x14
  volatile uint32_t BSRR;    // bit set/reset register,     0x18
  volatile uint32_t LCKR;    // conf. lock register,        0x1C
  volatile uint32_t AFR[2];  // altern. function registers, 0x20-0x24
  volatile uint32_t BRR;     // bit reset register, offset: 0x28
} GPIO_TypeDef;


#define GPIOA ((GPIO_TypeDef *) 0x50000000)
#define GPIOB ((GPIO_TypeDef *) 0x50000400)
#define GPIOC ((GPIO_TypeDef *) 0x50000800)
#define GPIOD ((GPIO_TypeDef *) 0x50000C00)
#define GPIOF ((GPIO_TypeDef *) 0x50001400)

typedef struct {
  volatile uint8_t  unused[0x34]; // 0x34 Bytes "überspringen"
  volatile uint32_t IOPENR;       // IO Port Enable register, 0x34
} RCC_TypeDef;

#define RCC ((RCC_TypeDef*) 0x40021000)  // Basisadresse RCC

RCC->IOPENR  |=  (1<<0);	// Takt für GPIOA aktivieren
RCC->IOPENR  |=  (1<<2);	// Takt für GPIOC aktivieren
GPIOA->MODER &= ~(1<<11);	// PA5 als Ausgang konfigurieren
GPIOA->MODER |=  (1<<10);	// dto.
GPIOC->MODER &= ~(3<<26);	// PC13 als Ausgang konfigurieren

while(1) {
    if (!(GPIOC->IDR & (1<<13))) {	// PC13 = low ?
        GPIOA->ODR ^= (1<<5);	      // dann PA5 invertieren
        for (volatile uint32_t cnt=0; cnt<1000000; cnt++); // warten
    }
}

