    # Aktivieren des Taktsignals für GPIOA und GPIOC
    ldr  r0,=0x40021034
    ldr  r1,[r0]
    movs r2,5            @ Bit 0 und 2 setzen
    orrs r1,r2
    str  r1,[r0]

    ldr  r0,=0x50000000  @ Basisadresse GPIOA nach r0
    ldr  r1,=0x50000800  @ Basisadresse GPIOC nach r1

    # PC13 als GPIO-Eingang konfigurieren
    ldr  r2,[r1]
    ldr  r3,=(3<<26)   @ Bit 26 und 27 von r3 auf 1
    bics r2,r3         @ r3 löscht Bit 26 und 27
    str  r2,[r1]

    # PA5 als GPIO-Ausgang konfigurieren
    ldr  r2,[r0]
    ldr  r3,=(3<<10)   @ Bit 10 und 11 von r3 auf 1
    bics r2,r3         @ r3 löscht Bit 10 und 11
    ldr  r3,=(1<<10)   @ Bit 10 von r3 auf 1
    orrs r2,r3         @ r3 setzt Bit 10
    str  r2,[r0]

    # PA5 in regelmäßigen zeitlichen Abständen invertieren,
    # wenn PC13 logisch 1 ist
    ldr  r3,=(1<<5)
    ldr  r4,=(1<<13)
blink_loop:
    ldr  r2,[r1,0x10]  @ lese GPIOC, Basisadresse + 0x10
    ands r2,r4         @ Bit 13 auswerten
    bne  blink_loop
    ldr  r2,[r0,0x14]  @ lese GPIOA, Basisadresse + 0x14
    eors r2,r3         @ Bit 5 invertieren
    str  r2,[r0,0x14]  @ schreibe GPIOA, Basisadresse + 0x14
    ldr  r5,=2000000   @ Zählerwert für Verzögerung
del_loop:
    subs r5,1
    bne  del_loop      @ r3 auf Null herunterzählen
    b    blink_loop    @ danach: nächste Invertierung von PA5
