#include "stm32g0xx_hal.h"

extern DAC_HandleTypeDef hdac1;
extern TIM_HandleTypeDef htim6;

#define DMA_BUFFER_SIZE 200

volatile uint16_t dacVals[DMA_BUFFER_SIZE];

// Diese Funktion füllt den halben DMA-Puffer mit Abtastwerten
// Der Parameter startIdx legt die Position des ersten Eintrags fest
void sawSweepToBuffer(uint8_t startIdx)
{
    const  int32_t fs   = 20000;
    const  int32_t fmin = 100;
    const  int32_t fmax = 1000;
    static int32_t f    = fmin;
    static int32_t samplesPerPeriod = fs/fmin;
    static int32_t n;

    for (int i=0; i<DMA_BUFFER_SIZE/2; i++) {
        dacVals[startIdx+i] = 4095*n/samplesPerPeriod;
        n++;
        if (n>=samplesPerPeriod) {
            n=0;
            f += 1;
            if (f>fmax) f = fmin;
            samplesPerPeriod = fs/f;
        }
    }
}

// DMA-Half-Complete-Callback
void HAL_DAC_ConvHalfCpltCallbackCh1 (DAC_HandleTypeDef * hdac)
{
}

// DMA-Complete-Callback
void HAL_DAC_ConvCpltCallbackCh1 (DAC_HandleTypeDef * hdac)
{
}

void app() // wird in main() aufgerufen
{
}
