// Dreieck- und Sinussignalerzeugung mit DAC
#include "math.h"  // für sin() und M_PI
#include "stm32g0xx_hal.h"

extern DAC_HandleTypeDef hdac1;
extern TIM_HandleTypeDef htim2;

volatile uint16_t dacVals1[256]; // Arrays für Ausgabewerte
volatile uint16_t dacVals2[256];

void app() // wird in main() aufgerufen
{
    for (int i=0; i<256; i++) { // Arrays mit Werten füllen
        dacVals1[i] = i<128? i*4095/128 : (256-i)*4095/128;
        dacVals2[i] = 2047+2047*sin(2.0*M_PI*i/256.0);
    }

    // DMA-Übertragungen für beide Kanäle starten
    HAL_DAC_Start_DMA (&hdac1,DAC_CHANNEL_1,
                       (uint32_t*)dacVals1,256,DAC_ALIGN_12B_R);
    HAL_DAC_Start_DMA (&hdac1,DAC_CHANNEL_2,
                       (uint32_t*)dacVals2,256,DAC_ALIGN_12B_R);
    // Timer TIM2 aktivieren
    HAL_TIM_Base_Start(&htim2);
    // Ab hier wird für dieses Beispiel 
    // keine Software-Interaktion mehr benötigt
    while (1);
}
