// DMA-Beispiel
// Konfiguration: zirkulär, Byte-Transfers, für Speicher Post-Inkrement

#include "stm32g0xx_hal.h"
#include "string.h"

extern UART_HandleTypeDef huart2;

volatile char DMABuffer[21];
volatile uint8_t cnt = 0;

void HAL_UART_TxHalfCpltCallback (UART_HandleTypeDef *huart)
{
    if (huart == &huart2) {
        cnt++;
        if (cnt > 9) cnt = 0;
        DMABuffer[8] = '0'+cnt;
    }
}

void HAL_UART_TxCpltCallback (UART_HandleTypeDef *huart)
{
    if (huart == &huart2) {
        cnt++;
        if (cnt > 9) cnt = 0;
        DMABuffer[18] = '0'+cnt;
    }
}

void app() // wird in main() aufgerufen
{
    strcpy(DMABuffer,"DMATest x\nDMATest x\n");
    HAL_UART_Transmit_DMA (&huart2,(uint8_t*)DMABuffer,20);

    while (1) {
    }
}
