// Senden eines Bytes
#include "stm32g0xx_hal.h"
extern I2C_HandleTypeDef hi2c1;
#define DS1337_I2C_ADDRESS_7BIT 0x68
typedef struct {
    uint8_t sec;
    uint8_t min;
    uint8_t hours;
    uint8_t wday;
    uint8_t date;
    uint8_t month;
    uint8_t year;
} DS1337_Register;
DS1337_Register rtcTime;
HAL_StatusTypeDef readDS1337 (DS1337_Register *rdTime)
{
    return HAL_I2C_Mem_Read(&hi2c1, DS1337_I2C_ADDRESS_7BIT<<1,
                             0, 1, (uint8_t*)rdTime, 7, 10);
}
HAL_StatusTypeDef writeDS1337 (DS1337_Register *wrTime)
{
    return HAL_I2C_Mem_Write(&hi2c1, DS1337_I2C_ADDRESS_7BIT<<1,
                             0, 1, (uint8_t*)wrTime, 7, 10);
}

void app() // wird in main() aufgerufen
{
    // Beispiel: Dienstag 7. Mai 2024, 15:34:56 Uhr
    // DS1337 nutzt die BCD-Darstellung
    // Daher wird zum Beispiel der Dezimalwert 15 als
    // hexadezimaler Wert 0x15 in den Registern abgelegt
    rtcTime.sec   = 0x56;
    rtcTime.min   = 0x34;
    rtcTime.hours = 0x15 | (1<<6); // Bit 6: 24h-Format
    rtcTime.wday  = 0x02; // Dienstag
    rtcTime.date  = 0x07;
    rtcTime.month = 0x05;
    rtcTime.year  = 0x24;
    writeDS1337(&rtcTime);  // Uhrzeit setzen

    while (1) {
        readDS1337(&rtcTime);  // Uhrzeit lesen
    }
}
