    // Beispiel für den Betrieb eines Timers mit CMSIS-Funktionen
    // Takte für GPIOA und TIM2 aktivieren
    RCC->IOPENR  |= RCC_IOPENR_GPIOAEN;
    RCC->APBENR1 |= RCC_APBENR1_TIM2EN;

    // PA0 und PA1 "Alternate Function" auf TIM2 einstellen
    GPIOA->MODER &= ~GPIO_MODER_MODE0;
    GPIOA->MODER |=  GPIO_MODER_MODE0_1;
    GPIOA->MODER &= ~GPIO_MODER_MODE1;
    GPIOA->MODER |=  GPIO_MODER_MODE1_1;

    GPIOA->AFR[0] &= ~GPIO_AFRL_AFSEL0;
    GPIOA->AFR[0] |=  2<<GPIO_AFRL_AFSEL0_Pos;
    GPIOA->AFR[0] &= ~GPIO_AFRL_AFSEL1;
    GPIOA->AFR[0] |=  2<<GPIO_AFRL_AFSEL1_Pos;

    // CH1: "Toggle" wenn CNT = CCR1, CH2: "Toggle" wenn CNT = CCR2
    TIM2->CCMR1  = TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1M_0;
    TIM2->CCMR1 |= TIM_CCMR1_OC2M_1 | TIM_CCMR1_OC2M_0;

    // Ausgang fuer Kanal 1 und 2 aktivieren
    TIM2->CCER   = TIM_CCER_CC2E | TIM_CCER_CC1E;

    // Presaler: Taktdivisor 16 (PSC=16-1), Zählimpulsfrequenz = 1 MHz
    TIM2->PSC    = 15;
    // ARR=999 => Neustart alle 1000 us
    TIM2->ARR    = 999;
    // Kanal 1: Invertierung 100 us nach Neustart
    TIM2->CCR1   = 99;
    // Kanal 2: Invertierung 200 us nach Neustart
    TIM2->CCR2   = 199;

    // CEN-Bit auf 1 => Timer starten
    TIM2->CR1   |= TIM_CR1_CEN;
