// Messung der Periodendauer und der Pulsbreite
#include "stm32g0xx_hal.h"
extern TIM_HandleTypeDef htim2;

volatile uint32_t period;
volatile uint32_t pulseWidth;

void HAL_TIM_IC_CaptureCallback(TIM_HandleTypeDef* htim)
{
    static uint32_t icRisingEdge;

    if (htim == &htim2) {
        if (htim->Channel == HAL_TIM_ACTIVE_CHANNEL_1) {
            uint32_t icRisingEdgePrevious = icRisingEdge;

            // Zeitpunkt "rising edge" aus Kanal 1 holen
            icRisingEdge = HAL_TIM_ReadCapturedValue(&htim2,TIM_CHANNEL_1);

            // Zeitpunkt "falling edge" aus Kanal 2 holen
            uint32_t icFallingEdge =
                           HAL_TIM_ReadCapturedValue(&htim2,TIM_CHANNEL_2);

            period = icRisingEdge-icRisingEdgePrevious;
            pulseWidth = icFallingEdge-icRisingEdgePrevious;
        }
    }
}

void app() // in main() aufrufen
{
    HAL_TIM_IC_Start_IT (&htim2,TIM_CHANNEL_1);
    HAL_TIM_IC_Start (&htim2,TIM_CHANNEL_2);
    while (1) {
        // z.B. hier period und pulseWidth auswerten
    }
}
