// Verarbeitung von Zähler-Überläufen am Beispiel der Messung
// der Periodendauer eines Eingangssignals
volatile uint64_t period;        // gemessene Periodenlänge
volatile uint32_t updateCounter; // Anzahl aufgetretener Update-Events

void HAL_TIM_PeriodElapsedCallback (TIM_HandleTypeDef* htim)
{
    updateCounter++;
}

void HAL_TIM_IC_CaptureCallback(TIM_HandleTypeDef* htim)
{
    static uint64_t icRisingEdge;

    if (htim == &htim2 && htim->Channel == HAL_TIM_ACTIVE_CHANNEL_1) {
        // vorherigen Capture-Wert sichern
        uint64_t icRisingEdgePrevious = icRisingEdge;
        // aktuellen Capture-Wert holen
        // und mit updateCounter erweitern
        // Annahme für diesen Code:
        // ARR besitzt den Maximalwert 0xFFFFFFFF
        icRisingEdge = (updateCounter<<32ULL) +
                      HAL_TIM_ReadCapturedValue(&htim2,TIM_CHANNEL_1);
        // Differenz entspricht Periodenlänge
        period = icRisingEdge - icRisingEdgePrevious;
    }
}
