// Vermessung der Periodenlänge von Signalen mit einem Timer
#include "stm32g0xx_hal.h"
extern TIM_HandleTypeDef htim2;

volatile uint32_t period; // gemessene Periodenlänge

void HAL_TIM_IC_CaptureCallback(TIM_HandleTypeDef* htim)
{
    static uint32_t icRisingEdge;

    if (htim == &htim2 && htim->Channel == HAL_TIM_ACTIVE_CHANNEL_1) {
        // vorherigen Capture-Wert sichern
        uint32_t icRisingEdgePrevious = icRisingEdge;
        // aktuellen Capture-Wert holen
        icRisingEdge = HAL_TIM_ReadCapturedValue(&htim2,TIM_CHANNEL_1);
        // Differenz entspricht Periodenlänge
        period = icRisingEdge - icRisingEdgePrevious;
    }
}

void app() // wird in main() aufgerufen
{
    HAL_TIM_IC_Start_IT (&htim2,TIM_CHANNEL_1);
    while (1) {
        // z.B. hier Variable period auswerten oder ausgeben
    }
}
