// Dynamische PWM-Signalerzeugung mit Timer
#include "stm32g0xx_hal.h"
extern TIM_HandleTypeDef htim2;

// Array mit CCR-Werten
volatile uint32_t ccr1Sequence[2] = {699,299};
volatile uint32_t arrSequence[2]  = {1799,1299};

void HAL_TIM_PeriodElapsedCallback (TIM_HandleTypeDef* htim)
{
    static uint8_t cnt = 0; // Zähler zur Auswahl der Werte

    if (htim == &htim2) {
        // Falls richtiger Timer: ARR- und CCR-Wert neu setzen
        __HAL_TIM_SET_COMPARE(htim,TIM_CHANNEL_1,ccr1Sequence[cnt]);
        __HAL_TIM_SET_AUTORELOAD(htim,arrSequence[cnt]);

        // ARR/CCR-Index erhöhen, max. bis 1 laufen lassen
        cnt = (cnt+1)%2;
    }
}
void app() // wird in main() aufgerufen
{
    HAL_TIM_PWM_Start (&htim2, TIM_CHANNEL_1);
    HAL_TIM_Base_Start_IT (&htim2);
    while (1);
}
